/////////////////////////////////////////////////////////////////////////////
//		cpuusage.c / cpuusage.cpp

#include <windows.h>
#include <pdh.h>
#pragma comment( lib, "pdh.lib" )


#ifdef __cplusplus
extern "C" {
#endif


//////////////////////////////////////////////////////////
//	錾

//֐
BOOL	InitCpuUsage( void );
BOOL	ExitCpuUsage( void );
DWORD	GetCpuUsage( void );
DWORD	GetCpuFreq( void );

//萔
#define	COUNTER_PATH	__TEXT("\\Processor(_Total)\\% Processor Time")
#define	rdtsc			_asm _emit 0Fh _asm _emit 31h

//ϐ
static	HQUERY		m_hQuery;
static	HCOUNTER	m_hCounter;


//////////////////////////////////////////////////////////
//	֐

BOOL	InitCpuUsage( void )
{
	if( PdhOpenQuery( NULL, 0, &m_hQuery ) != ERROR_SUCCESS ) {
		return	FALSE;
	}

	if( PdhAddCounter( m_hQuery, COUNTER_PATH, 0, &m_hCounter ) != ERROR_SUCCESS ) {
		return	FALSE;
	}

	PdhCollectQueryData( m_hQuery );

	return	TRUE;
}

BOOL	ExitCpuUsage( void )
{
	PdhRemoveCounter( m_hCounter );
	PdhCloseQuery( m_hQuery );

	return	TRUE;
}

DWORD	GetCpuUsage( void )
{
	PDH_FMT_COUNTERVALUE	FmtValue;

	PdhCollectQueryData( m_hQuery );
	PdhGetFormattedCounterValue( m_hCounter, PDH_FMT_LONG, NULL, &FmtValue );

	return	FmtValue.longValue;
}

DWORD	GetCpuFreq( void )
{
	static	LONGLONG	nOldCount = 0;
	static	LONGLONG	nOldCycle = 0;

	LONGLONG			nCount;
	LONGLONG			nCycle;
	LONGLONG			nFreq;

	DWORD				nUsage = 0;

	QueryPerformanceCounter  ( (LARGE_INTEGER *) &nCount );
	QueryPerformanceFrequency( (LARGE_INTEGER *) &nFreq  );
	__asm	{
		rdtsc
		mov		dword ptr [nCycle   ],eax
		mov		dword ptr [nCycle+4h],edx
	}

	if( nOldCount != 0 )
	{
//		nUsage = ( nCycle - nOldCycle ) / ( ( nCount - nOldCount ) / nFreq );
		__asm	{
			fild	qword ptr [nCycle]
			fild	qword ptr [nOldCycle]
			fsubp	st(1),st
			fild	qword ptr [nCount]
			fild	qword ptr [nOldCount]
			fsubp	st(1),st
			fild	qword ptr [nFreq]
			fdivp	st(1),st
			fdivp	st(1),st
			fistp	dword ptr [nUsage]
		}
	}

	nOldCount = nCount;
	nOldCycle = nCycle;

	return	nUsage;
}


#ifdef __cplusplus
}	//extern "C"
#endif
