/////////////////////////////////////////////////////////////////////////////
//		sntp.c / sntp.cpp

#include <windows.h>
#include <winsock.h>


#ifdef __cplusplus
extern "C" {
#endif


//////////////////////////////////////////////////////////
//	錾

//	NTPpPbg
struct NTP_Packet
{
	int Control_Word;
	int root_delay;
	int root_dispersion;
	int reference_identifier;
	__int64 reference_timestamp;
	__int64 originate_timestamp;
	__int64 receive_timestamp;
	int transmit_timestamp_seconds;
	int transmit_timestamp_fractions;
};


//////////////////////////////////////////////////////////
//	֐

//	NTPT[o玞擾
#if UNICODE
INT GetServerTime( SYSTEMTIME* tm, LPCWSTR szServerW, SHORT nPort )
{
	CHAR szServer[256];
#else
INT GetServerTime( SYSTEMTIME* tm, LPCSTR szServer, SHORT nPort )
{
#endif

	WORD wVersionRequested;
	int nErrorStatus;
	WSADATA wsaData;

	int soc;									/* \PbgiSoket Descriptorj */
	unsigned long serveraddr;					/* T[oIPAhX */
	struct hostent *serverhostent;				/* T[ȍw|C^ */
	struct sockaddr_in sockname;				/* \Pbg̃AhX */
	struct sockaddr_in serversockaddr;			/* T[õAhX */
	int sockaddr_Size;							/* T[õAhX̃TCY */
	struct NTP_Packet NTP_Send;					/* MNTPpPbg */
	struct NTP_Packet NTP_Recv;					/* MNTPpPbg */
	fd_set rdps;
	struct timeval waittime;
	int selret;
	unsigned short local_port = 1024;			/* M|[gԍ */
	__int64	ft;

#if UNICODE
	WideCharToMultiByte( CP_ACP, 0, szServerW, -1, szServer, 256, NULL, NULL );
#endif

	/* WinSock̏s */
	wVersionRequested = MAKEWORD(1,1);						/* o[W 1.1 v */
	nErrorStatus = WSAStartup(wVersionRequested, &wsaData);
	if(nErrorStatus != 0){
		return -1;		// Error: WinSock̏s
	}

	/* UDP[hsocɃ\Pbg쐬܂ */
	soc = socket(PF_INET,SOCK_DGRAM,0);
	if(soc == INVALID_SOCKET){
		return -1;		// Error: Socket쐬s
	}

	/* \Pbg̃AhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	sockname.sin_family       = AF_INET;							/* C^[lbg̏ꍇ */
	sockname.sin_addr.s_addr  = INADDR_ANY;							/* IPAhXg悤ɂ */
	sockname.sin_port         = htons((unsigned short)local_port);	/* M|[gԍ */
	memset(sockname.sin_zero,(int)0,sizeof(sockname.sin_zero));
	if(bind(soc,(struct sockaddr *)&sockname,sizeof(sockname)) == SOCKET_ERROR){
		// M|[gԍ̎wɎs
	}

	/* svNameɃhbgt10iŕ\IPAhXĂꍇAserveraddr32bitIPAhXԂ܂ */
	serveraddr = inet_addr(szServer);
	if(serveraddr == -1) {
		/* T[o(svName)T[ȍ擾܂ */
		serverhostent = gethostbyname(szServer);
		if(serverhostent == NULL) {
			/* \Pbgj */
			closesocket(soc);
			return -1;		// Error: zXgAhX擾s
		}else{
			/* T[ȍ񂩂IPAhXserveraddrɃRs[܂ */
			serveraddr = *((unsigned long *)((serverhostent->h_addr_list)[0]));
		}
	}

	/* T[õAhX̍\̂ɃT[oIPAhXƃ|[gԍݒ肵܂ */
	serversockaddr.sin_family       = AF_INET;							/* C^[lbg̏ꍇ */
	serversockaddr.sin_addr.s_addr  = serveraddr;						/* T[oIPAhX */
	serversockaddr.sin_port         = htons((unsigned short)nPort);		/* |[gԍ */
	memset(serversockaddr.sin_zero,(int)0,sizeof(serversockaddr.sin_zero));

	/* NTPpPbgSNTPpɏ */
	NTP_Send.Control_Word = htonl(0x0B000000);
	NTP_Send.root_delay = 0;
	NTP_Send.root_dispersion = 0;
	NTP_Send.reference_identifier = 0;
	NTP_Send.reference_timestamp = 0;
	NTP_Send.originate_timestamp = 0;
	NTP_Send.receive_timestamp = 0;
	NTP_Send.transmit_timestamp_seconds = 0;
	NTP_Send.transmit_timestamp_fractions = 0;

	/* T[ow肵NTPpPbg𑗐M */
	if(sendto(soc,(const char *)&NTP_Send, sizeof( NTP_Send ),0,(struct sockaddr *)&serversockaddr,sizeof(serversockaddr)) == SOCKET_ERROR){
		/* \Pbgj */
		closesocket(soc);
		return -1;		// Error: T[oւ̑Ms
	}

	/* select֐gă^CAEgݒ肷 */
	waittime.tv_sec = 3;			/* ^CAEgbݒ肷 */
	waittime.tv_usec = 0;
	FD_ZERO(&rdps);
	FD_SET(soc,&rdps);				/* select\Pbgǉ */

	selret = select(FD_SETSIZE,&rdps,(fd_set *)0,(fd_set *)0,&waittime);
	if(selret == SOCKET_ERROR){					/* G[̏ꍇ */
		/* \Pbgj */
		closesocket(soc);
		return -1;		// T[o̎Ms
	}
	if(selret == 0){				/* ^CAEg̏ꍇ */
		/* \Pbgj */
		closesocket(soc);
		return -1;		// Error: ^CAEg܂
	}
	if(FD_ISSET(soc,&rdps) == FALSE){	/* M͂Aw̃\Pbgł͂Ȃꍇ */
		/* \Pbgj */
		closesocket(soc);
		return -1;		// T[o̎Ms
	}

	/* T[ow肵ĎMs */
	sockaddr_Size = sizeof(serversockaddr);
	if(recvfrom(soc, (char *)&NTP_Recv, sizeof(NTP_Recv), 0,(struct sockaddr *)&serversockaddr,&sockaddr_Size) == SOCKET_ERROR ){
		/* \Pbgj */
		closesocket(soc);
		return -1;		// Error: T[o̎Ms
	}

	/* \Pbgj */
	closesocket(soc);

	/* NTPT[o擾nԂɕϊ */
	//	NTPT[o̖߂l 1900N11 ̕bł
	//	FILETIME \̂ 1601N11  10-7 bԊu̐ł
	ft = (__int64)ntohl(NTP_Recv.transmit_timestamp_seconds)*10000000;
	ft += (__int64)109207*24*60*60*10000000;
	ft += (__int64)ntohl(NTP_Recv.transmit_timestamp_fractions)/500;	//5000000000/10000000
	FileTimeToLocalFileTime( (FILETIME*)&ft, (FILETIME*)&ft );
	FileTimeToSystemTime( (FILETIME*)&ft, tm );

	/* WinSock̃\[X */
	WSACleanup();

	return	0;
}


#ifdef __cplusplus
}	//extern "C"
#endif
